/* =============================================================================
 *
 *  Description: This is a C++ to C Thread Header file for Thread Main
 *
 * -----------------------------------------------------------------------------
 *  Comments:
 *
 * ===========================================================================*/

#ifndef _Main_H_
#define _Main_H_

#pragma diag(push)
#pragma diag(suppress: 177,401,451,826,831,1462)

#include "VDK.h"
#pragma diag(pop)

#ifdef __ECC__	/* for C/C++ access */
#ifdef __cplusplus
extern "C" void Main_InitFunction(void**, VDK::Thread::ThreadCreationBlock *);
#else
extern "C" void Main_InitFunction(void**, VDK_ThreadCreationBlock *);
#endif
extern "C" void Main_DestroyFunction(void**);
extern "C" int  Main_ErrorFunction(void**);
extern "C" void Main_RunFunction(void**);
#endif /* __ECC__ */

#ifdef __cplusplus
#include <new>

class Main_Wrapper : public VDK::Thread
{
public:
    Main_Wrapper(VDK::ThreadCreationBlock &t)
        : VDK::Thread(t)
    { Main_InitFunction(&m_DataPtr, &t); }

    ~Main_Wrapper()
    { Main_DestroyFunction(&m_DataPtr); }

    int ErrorHandler()
    { 
      return Main_ErrorFunction(&m_DataPtr);
     }

    void Run()
    { Main_RunFunction(&m_DataPtr); }

    static VDK::Thread* Create(VDK::Thread::ThreadCreationBlock &t)
    { return new (t) Main_Wrapper(t); }
};

#endif /* __cplusplus */
#endif /* _Main_H_ */

/* ========================================================================== */
